## net.sf.saxon.event
Class Emitter

    java.lang.Object
      net.sf.saxon.event.Emitter

All Implemented Interfaces:
  javax.xml.transform.Result, Receiver

Direct Known Subclasses:
  PTreeEmitter, XMLEmitter

    public abstract class Emitter

extends java.lang.Object
implements javax.xml.transform.Result, Receiver

Emitter: This abstract class defines methods that must be implemented by components that format SAXON output. There is one emitter for XML, one for HTML, and so on. Additional methods are concerned with setting options and providing a Writer.

The interface is deliberately designed to be as close as possible to the standard SAX2 ContentHandler interface, however, it allows additional information to be made available. An Emitter is a Receiver, specifically it is a Receiver that can direct output to a Writer or OutputStream, using serialization properties defined in a Properties object.

Field Summary
`protected boolean` `allCharactersEncodable`
`protected CharacterSet` `characterSet`
`protected NamePool` `namePool`
`protected java.util.Properties` `outputProperties`
`protected java.io.OutputStream` `outputStream`
`protected PipelineConfiguration` `pipelineConfig`
`protected javax.xml.transform.stream.StreamResult` `streamResult`
`protected java.lang.String` `systemId`
`protected java.io.Writer` `writer`

Constructor Summary
`Emitter()`

Method Summary
`Configuration` `getConfiguration()` Get the configuration used for this document
`java.util.Properties` `getOutputProperties()` Get the output properties
`java.io.OutputStream` `getOutputStream()` Get the output stream
`PipelineConfiguration` `getPipelineConfiguration()` Get the pipeline configuration used for this document
`java.lang.String` `getSystemId()` Get the System ID
`java.io.Writer` `getWriter()` Get the output writer
`protected void` `makeWriter()` Make a Writer for this Emitter to use, given a StreamResult.
`void` `setOutputProperties(java.util.Properties details)` Set output properties
`void` `setOutputStream(java.io.OutputStream stream)` Set the output destination as a byte stream
`void` `setPipelineConfiguration(PipelineConfiguration pipe)` Set the pipelineConfiguration
`void` `setStreamResult(javax.xml.transform.stream.StreamResult result)` Set the StreamResult acting as the output destination of the Emitter
`void` `setSystemId(java.lang.String systemId)` Set the System ID
`void` `setUnparsedEntity(java.lang.String name, java.lang.String uri, java.lang.String publicId)` Set unparsed entity URI.
`void` `setWriter(java.io.Writer writer)` Set the output destination as a character stream
`boolean` `usesWriter()` Determine whether the Emitter wants a Writer for character output or an OutputStream for binary output.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface net.sf.saxon.event.Receiver
`attribute, characters, close, comment, endDocument, endElement, namespace, open, processingInstruction, startContent, startDocument, startElement`

Field Detail

### pipelineConfig

    protected PipelineConfiguration pipelineConfig

### namePool

    protected NamePool namePool

### systemId

    protected java.lang.String systemId

### streamResult

    protected javax.xml.transform.stream.StreamResult streamResult

### writer

    protected java.io.Writer writer

### outputStream

    protected java.io.OutputStream outputStream

### outputProperties

    protected java.util.Properties outputProperties

### characterSet

    protected CharacterSet characterSet

### allCharactersEncodable

    protected boolean allCharactersEncodable

Constructor Detail

### Emitter

    public Emitter()

Method Detail

### setPipelineConfiguration

    public void setPipelineConfiguration(PipelineConfiguration pipe)

  Set the pipelineConfiguration

  Specified by:
    `setPipelineConfiguration` in interface `Receiver`
  Parameters:
    `pipe` - the pipeline configuration

### getPipelineConfiguration

    public PipelineConfiguration getPipelineConfiguration()

  Get the pipeline configuration used for this document

  Specified by:
    `getPipelineConfiguration` in interface `Receiver`
  Returns:
    the pipeline configuration

### getConfiguration

    public Configuration getConfiguration()

  Get the configuration used for this document

  Returns:
    the configuration

### setSystemId

    public void setSystemId(java.lang.String systemId)

  Set the System ID

  Specified by:
    `setSystemId` in interface `javax.xml.transform.Result`
  Specified by:
    `setSystemId` in interface `Receiver`
  Parameters:
    `systemId` - the system identifier (=base URI)

### getSystemId

    public java.lang.String getSystemId()

  Get the System ID

  Specified by:
    `getSystemId` in interface `javax.xml.transform.Result`

### setOutputProperties

    public void setOutputProperties(java.util.Properties details)
                             throws XPathException

  Set output properties

  Parameters:
    `details` - the output serialization properties
  Throws:
    `XPathException`

### getOutputProperties

    public java.util.Properties getOutputProperties()

  Get the output properties

  Returns:
    the output serialization properties

### setStreamResult

    public void setStreamResult(javax.xml.transform.stream.StreamResult result)
                         throws XPathException

  Set the StreamResult acting as the output destination of the Emitter

  Parameters:
    `result` - the output destination
  Throws:
    `XPathException`

### makeWriter

    protected void makeWriter()
                       throws XPathException

  Make a Writer for this Emitter to use, given a StreamResult.

  Throws:
    `XPathException`

### usesWriter

    public boolean usesWriter()

  Determine whether the Emitter wants a Writer for character output or an OutputStream for binary output. The standard Emitters all use a Writer, so this returns true; but a subclass can override this if it wants to use an OutputStream

  Returns:
    true if a Writer is needed, as distinct from an OutputStream

### setWriter

    public void setWriter(java.io.Writer writer)
                   throws XPathException

  Set the output destination as a character stream

  Parameters:
    `writer` - the Writer to use as an output destination
  Throws:
    `XPathException`

### getWriter

    public java.io.Writer getWriter()

  Get the output writer

  Returns:
    the Writer being used as an output destination, if any

### setOutputStream

    public void setOutputStream(java.io.OutputStream stream)
                         throws XPathException

  Set the output destination as a byte stream

  Parameters:
    `stream` - the OutputStream being used as an output destination
  Throws:
    `XPathException`

### getOutputStream

    public java.io.OutputStream getOutputStream()

  Get the output stream

  Returns:
    the OutputStream being used as an output destination, if any

### setUnparsedEntity

    public void setUnparsedEntity(java.lang.String name,
                                  java.lang.String uri,
                                  java.lang.String publicId)
                           throws XPathException

  Set unparsed entity URI. Needed to satisfy the Receiver interface, but not used, because unparsed entities can occur only in input documents, not in output documents.

  Specified by:
    `setUnparsedEntity` in interface `Receiver`
  Parameters:
    `name` - the entity name
    `uri` - the entity system ID
    `publicId` - the entity public ID
  Throws:
    `XPathException`

Copyright (c) Saxonica Limited. All rights reserved.